unit TGLIpAddresses;

(* Copyright 2001 TGL MIcrosystems                                     *)
(* You may use this code freely for both commercial and non-commercial *)
(* applications. You may NOT remove this notice from the component     *)

(* Returns a list of both routable and non-routable IP addresses       *)
(* Call Refresh to update the lists                                    *) 


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, Winsock;

type
  TTGLIpAddresses = class(TCOMPONENT)
  private
    { Private declarations }
    fInternalIPList: TStringlist;
    fExternalIPList: TStringlist;
  protected
    { Protected declarations }
    procedure Loaded; override;
    function GetInternalIPList: TStrings;
    function GetExternalIPList: TStrings;
  public
    { Public declarations }
    constructor create(Aowner: TComponent); override;
    destructor Destroy; override;
    procedure Refresh; virtual;
  published
    { Published declarations }
    property InternalIPList: TStrings read GetInternalIPList;
    property ExternalIPList: TStrings read GetExternalIPList;
  end;
  TaPInAddr=Array[0..50] of PInAddr;
  PaPInAddr=^TaPInAddr;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('TGLTCP', [TTGLIpAddresses]);
end;

{ TTGLIpAddresses }

constructor TTGLIpAddresses.create(Aowner: TComponent);
begin
    inherited;
    fInternalIPList:=TStringlist.create;
    fExternalIPList:=TStringlist.create;
end;

destructor TTGLIpAddresses.Destroy;
begin
    inherited;
    fInternalIPList.free;
    fExternalIPList.free;
end;

function TTGLIpAddresses.GetExternalIPList: TStrings;
begin
    Result:=fExternalIPList;
end;

function TTGLIpAddresses.GetInternalIPList: TStrings;
begin
    Result:=fInternalIPList;
end;

procedure TTGLIpAddresses.Loaded;
begin
    inherited;
    Refresh;
end;

procedure TTGLIpAddresses.Refresh;
var
    Init: TWSAData;
    phe: PHostEnt;
    pptr: PaPInAddr;
    i: Word;
    buff: pointer;
    s: string;
begin
    WSAStartup($101, Init);
    getmem(buff,64);
    Fillchar(buff^,64,#0);
    GetHostName(Buff, 64);
    phe:=GetHostByName(buff);
    freemem(buff);
    if (phe=nil) then Exit;
    pPtr:=PaPInAddr(phe^.h_addr_list);
    i:=0;
    while (pPtr^[i]<>nil) do begin
        s:=inet_ntoa(pptr^[i]^);
        if (copy(s,1,3)='10.') or (copy(s,1,4)='172.') or (copy(s,1,4)='192.') then
            fInternalIPList.Add(S)
        else
            fExternalIPList.Add(S);
        Inc(i);
    end;
    WSACleanup;
end;

end.
